﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using GTA;
using GTA.Native;
using System.IO;

namespace ScriptHookVDotNetExample
{
    public class meteormod : Script
    {
        bool meteorrainenabled = true;
        List<Ped> meteors = new List<Ped>();
        List<Prop> boulders = new List<Prop>();
        bool isonmeteorrain = false;
        int meteorruns = 0;
        int meteormaxruns = 25;
        Ped meteorped = null;
        Prop boulder = null;
        Random jedijosh920complexai = new Random();
        ScriptSettings scset;
        bool useped = false;
        float distance = 10f;
        float chance = 2;
        int timebetweenrains = 10000;
        int timebetweenrolls = 1000;
        int maxboulders = 25;
        int curwait = 0;

        public meteormod()
        {
            Tick += OnTick;
            try
            {
                if (!File.Exists("scripts\\meteormod.ini"))
                {
                    File.Create("scripts\\meteormod.ini").Close();
                }
                
                foreach (Prop prp in World.GetNearbyProps(Game.Player.Character.Position, 100f))
                {
                    if (prp.Model == "prop_test_boulder_02")
                    {
                        prp.Delete();
                    }
                }

                scset = ScriptSettings.Load("scripts\\meteormod.ini");

                if (scset == null)
                {
                    scset.SetValue("MeteorMod", "chance", 0.25f);
                    scset.SetValue("MeteorMod", "enabled", true);
                    scset.SetValue("MeteorMod", "complexai_distance", 10f);
                    scset.SetValue("MeteorMod", "maxmeteorsatatime", 25);
                    scset.SetValue("MeteorMod", "useped", false);
                    scset.SetValue("MeteorMod", "timebetweenrains", 10000);
                    scset.SetValue("MeteorMod", "timebetweenrolls", 1000);
                    scset.SetValue("MeteorMod", "maxboulders", 25);
                    scset.Save();
                    scset = ScriptSettings.Load("scripts\\meteormod.ini");
                }

                chance = scset.GetValue("MeteorMod", "chance", 0.25f);
                meteorrainenabled = scset.GetValue("MeteorMod", "enabled", true);
                distance = scset.GetValue("MeteorMod", "complexai_distance", 10f);
                meteormaxruns = scset.GetValue("MeteorMod", "maxmeteorsatatime", 25);
                useped = scset.GetValue("MeteorMod", "useped", false);
                timebetweenrains = scset.GetValue("MeteorMod", "timebetweenrains", 10000);
                timebetweenrolls = scset.GetValue("MeteorMod", "timebetweenrolls", 1000);
                maxboulders = scset.GetValue("MeteorMod", "maxboulders", 25);
                scset.Save();

                curwait = Game.GameTime + timebetweenrolls;
            }
            catch
            {

            }
        }
        
        void OnTick(object sender, EventArgs e)
        {
            try
            {
                if (boulders.Count > maxboulders)
                {
                    Prop bldr = boulders[0];
                    bldr.Delete();
                    boulders.Remove(bldr);
                }

                if (meteorrainenabled)
                {
                    if (isonmeteorrain)
                    {
                        if (useped)
                        {
                            if (meteorped != null && meteorped.HeightAboveGround < 2)
                            {
                                World.AddExplosion(meteorped.Position - new GTA.Math.Vector3(0, 0, meteorped.HeightAboveGround), ExplosionType.Barrel, 4f, 1f);
                                boulder.Detach();
                                foreach (Ped pd in World.GetNearbyPeds(meteorped.Position, 50f))
                                {
                                    try
                                    {
                                        if (pd.Handle != Game.Player.Character.Handle)
                                        {
                                            pd.Task.ClearAllImmediately();
                                            pd.Task.FleeFrom(meteorped.Position);
                                        }
                                    }
                                    catch
                                    {

                                    }
                                }
                            }

                            if (meteorped.HeightAboveGround < 3 && meteorruns <= meteormaxruns)
                            {
                                meteors.Add(meteorped);

                                meteorped = World.CreateRandomPed(Game.Player.Character.Position.Around(10f) + new GTA.Math.Vector3(0, 0, 10f));
                                boulder = World.CreateProp("prop_test_boulder_02", meteorped.Position, true, false);
                                boulders.Add(boulder);
                                boulder.AttachTo(meteorped, 65068);
                                meteorped.Alpha = 0;
                                if (!useped)
                                {
                                    boulder.Detach();
                                }
                                meteorruns++;
                            }

                            if (meteorruns > meteormaxruns)
                            {
                                meteors.Add(meteorped);
                                foreach (Ped pd in meteors)
                                {
                                    pd.Delete();
                                }
                                isonmeteorrain = false;
                                curwait = Game.GameTime + timebetweenrains;
                            }
                        }
                        else
                        {
                            if (boulder != null && boulder.HeightAboveGround < 3)
                            {
                                World.AddExplosion(boulder.Position - new GTA.Math.Vector3(0, 0, boulder.HeightAboveGround), ExplosionType.Barrel, 4f, 1f);
                                foreach (Ped pd in World.GetNearbyPeds(boulder.Position, 50f))
                                {
                                    try
                                    {
                                        if (pd.Handle != Game.Player.Character.Handle)
                                        {
                                            pd.Task.ClearAllImmediately();
                                            pd.Task.FleeFrom(boulder.Position);
                                        }
                                    }
                                    catch
                                    {

                                    }
                                }
                            }

                            if (boulder.HeightAboveGround < 3 && meteorruns <= meteormaxruns)
                            {
                                meteorped = World.CreateRandomPed(Game.Player.Character.Position.Around(10f) + new GTA.Math.Vector3(0, 0, 10f));
                                boulder = World.CreateProp("prop_test_boulder_02", meteorped.Position, true, false);
                                boulders.Add(boulder);
                                boulder.AttachTo(meteorped, 65068);
                                boulder.Detach();
                                meteorped.Delete();
                                meteorruns++;
                            }

                            if (meteorruns > meteormaxruns)
                            {
                                isonmeteorrain = false;
                                curwait = Game.GameTime + timebetweenrains;
                            }
                        }
                    }
                    else if ((jedijosh920complexai.Next(0, 10000) / 100) <= chance && Game.GameTime > curwait) //if it is 1 or 2, so there is %2 chance
                    {
                        UI.Notify("Meteor Rain Starting, Get Ready!");
                        isonmeteorrain = true;
                        meteorped = World.CreateRandomPed(Game.Player.Character.Position.Around(10f) + new GTA.Math.Vector3(0, 0, 10f));
                        boulder = World.CreateProp("prop_test_boulder_02", meteorped.Position, true, false);
                        boulders.Add(boulder);
                        boulder.AttachTo(meteorped, 65068);
                        meteorped.Alpha = 0;
                        if (!useped)
                        {
                            boulder.Detach();
                            meteorped.Delete();
                        }
                        curwait = Game.GameTime + timebetweenrolls;
                    }
                }
            }
            catch
            {

            }
        }
    }
}
